﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace RadComboBox_WPF_739759
{

    public class MainViewModel : INotifyPropertyChanged
    {
        private readonly List<Item> _items = new List<Item>();
        private Item _selectedItem;

        public MainViewModel()
        {
            // http://www.random.org/strings/?num=10&len=10&upperalpha=on&loweralpha=on&unique=on&format=plain&rnd=new
            _items.Add(new Item { Name = "Eg Zomh JywS" });
            _items.Add(new Item { Name = "Ua Qvp Lavwz" });
            _items.Add(new Item { Name = "Nee Lzx Rdaq" });
            _items.Add(new Item { Name = "Um Ztgi Yvsg" });
            _items.Add(new Item { Name = "tma Oppt fzd" });
            _items.Add(new Item { Name = "Du Zofcy Fbs" });
            _items.Add(new Item { Name = "bc Ey Ppvvcp" });
            _items.Add(new Item { Name = "Mv RSIZtf WE" });
            _items.Add(new Item { Name = "BFb YYZ PHwC" });
            _items.Add(new Item { Name = "YSW LQ DXxHu" });
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public IEnumerable<Item> Items { get { return _items; } }

        public Item SelectedItem
        {
            get { return _selectedItem; }
            set
            {
                _selectedItem = value;
                OnPropertyChanged("SelectedItem");
                OnPropertyChanged("SelectedItemName");
            }
        }

        public string SelectedItemName
        {
            get { return _selectedItem != null ? _selectedItem.Name : null; }
            set
            {
                if (_selectedItem != null)
                {
                    _selectedItem.Name = value;
                    
                    OnPropertyChanged("SelectedItemName");
                    OnPropertyChanged("SelectedItem");
                }
            }
        }

        protected virtual void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

}
